﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

namespace GameState
{
    public class Plane : Sprite
    {
        public int health;

        float faceLeft = MathHelper.PiOver2 * -1;
        float faceDown = MathHelper.Pi;
        float faceRight = MathHelper.PiOver2;
        float faceUp = 0;
        public Vector2 wayPoint;
        public Vector2 direction;
        float distanceToWaypoint;
        int waypointCounter = 0;

        SpriteManager game1;//reference for the main class

        //Constructor
        public Plane(Texture2D Texture, Vector2 Position, float Speed)
            : base(Texture, Position, Speed)
        {
            this.health = 100; 
            this.rotation = faceLeft;
            this.wayPoint = new Vector2(716, 56);//new Vector2(79, 55);//Point which plane trys to reach
            this.direction = new Vector2(0, 0);//Vector for the direction it must go
        }

        public override void Update(GameTime gameTime, Rectangle clientBounds)
        {
            //Changing the health of the planes, TEMPORARY
            GamePadState gamepadState = GamePad.GetState(PlayerIndex.One);
            if (gamepadState.Buttons.A == ButtonState.Pressed)
                health += 1;
            if (gamepadState.Buttons.B == ButtonState.Pressed)
                health -= 1;

            #region Direction Calculations
            //Subtracts the vector for the current position of the plane subtracted from the vector of the point you are trying to reach
            direction = -(this.position - this.wayPoint);
            //Scales the vector to 1
            direction.Normalize();

            //Adds the current position of the ship to the direction times the speed of the ship
            position = position + (direction * this.speed);
            #endregion

            #region Getting Next Waypoint
            distanceToWaypoint = Vector2.Distance(position, wayPoint);
            //If the distance to waypoint is less than one, considered at location and next waypoint is needed.
            if (distanceToWaypoint < 1)
            {
                //Code needed to get the next waypoint.
                //If the plane is at the current wayPoint then get the next waypoint
                //If there is no more wayPoints the end of the path is reached and plane must be destroyed
                //Then the remaining health of the plane is subtracted from the health of the battleship  
                waypointCounter++;
                if (waypointCounter == game1.wayPoints.Count)
                {
                    //Deque this plane, reached destination
                    //Put remaining health as damage to the battleship                    

                    waypointCounter = 0;//temporary                    
                }
                wayPoint = game1.wayPoints[waypointCounter];//new waypoint given to plane when at the previous waypoint location.
            }
            #endregion

            #region Plane Facing Direction
            //Changing the way the plane points relative to its direction
            if (direction.Y > 0)
                this.rotation = faceDown;
            if (direction.Y < 0)
                this.rotation = faceUp;
            if (direction.X > 0)
                this.rotation = faceRight;
            if (direction.X < 0)
                this.rotation = faceLeft;
            #endregion

            //Makes sure the health stays between 0 and 100
            health = (int)MathHelper.Clamp(health, 0, 100);

            base.Update(gameTime, clientBounds);
        }

        public override void Draw(GameTime gameTime, SpriteBatch spriteBatch)
        {

            base.Draw(gameTime, spriteBatch);
        }
    }
}
