﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

namespace GameState
{
    public class Sprite
    {
        #region List Members

        //List Members
        public Texture2D textureImage;
        public Vector2 position;
        public Vector2 velocity;
        public float rotation;
        public float speed;

        //public float DistanceToDestination
        //{
        //    get { return Vector2.Distance(position, directionPoint); }
        //}

        #endregion

        #region Constructors

        //3 Constructors
        public Sprite(Texture2D Texture, Vector2 Position, float Speed)
        {
            textureImage = Texture;
            position = Position;
            speed = Speed;
            velocity = Vector2.Zero;
        }

        public Sprite(Texture2D Texture, Vector2 Position)
        {
            textureImage = Texture;
            position = Position;
            speed = 0f;
            velocity = Vector2.Zero;
        }

        public Sprite(Texture2D Texture)
        {
            textureImage = Texture;
            speed = 0f;
            velocity = Vector2.Zero;
        }

        #endregion

        #region Methods

        public virtual void Update(GameTime gameTime, Rectangle clientBounds)
        {
            //Window boundries
            if (position.X < 1)
                position.X = 1;
            if (position.Y < textureImage.Width / 1.8f)
                position.Y = textureImage.Width / 1.8f;
            if (position.X > clientBounds.Width - textureImage.Width / 1.8f)
                position.X = clientBounds.Width - textureImage.Width / 1.8f;
            if (position.Y > clientBounds.Height - textureImage.Height / 1.8f)
                position.Y = clientBounds.Height - textureImage.Height / 1.8f;

        }

        public virtual void Draw(GameTime gameTime, SpriteBatch spriteBatch)
        {
            spriteBatch.Draw(textureImage, position, null, Color.White, rotation,
                new Vector2(textureImage.Height / 2, textureImage.Width / 2), 1.0f, SpriteEffects.None, 1);
        }
        #endregion
    }
}
